# Yahoo! UI Library

### datasource 3.3.0

Yahoo! UI Library > datasource > DataSource.IO
Search:
Filters Show Private Show Protected Show Deprecated

## Class DataSource.IO - extends DataSource.Local

IO subclass for the DataSource Utility.

### Constructor

DataSource.IO `( )`

### Properties

#### _queue - `private Object`

Object literal to manage asynchronous request/response cycles enabled if queue needs to be managed (asyncMode/ioConnMode):

interval {Number}
  Interval ID of in-progress queue.
conn
  In-progress connection identifier (if applicable).
requests {Object[]}
  Array of queued request objects: {request:request, callback:callback}.

Default Value: {interval:null, conn:null, requests:[]}

#### NAME - `static final String`

Class name.

#### Properties inherited from Plugin.Host:

`PluginHost`

#### Properties inherited from Attribute:

``

#### Properties inherited from Base:

`name`

#### Properties inherited from DataSource.Local:

``

### Methods

#### _defRequestFn

`protected void _defRequestFn ( e )`
Passes query string to IO. Fires `response` event when response is received asynchronously.

Parameters:
  `e <Event.Facade>` Event Facade with the following properties:
  tId (Number)
    Unique transaction ID.
  request (Object)
    The request.
  callback (Object)
    The callback object with the following properties:
    success (Function)
      Success handler.
    failure (Function)
      Failure handler.
  cfg (Object)
    Configuration object.

#### failureHandler

`private void failureHandler ( id , response , e )`
IO failure callback.

Parameters:
  `id <String>` Transaction ID.
  `response <String>` Response.
  `e <Event.Facade>` Event facade.

#### initializer

`private void initializer ( config )`
Internal init() handler.

Parameters:
  `config <Object>` Config object.

#### successHandler

`private void successHandler ( id , response , e )`
IO success callback.

Parameters:
  `id <String>` Transaction ID.
  `response <String>` Response.
  `e <Event.Facade>` Event facade.

#### Methods inherited from EventTarget:

`_getType, _monitor, _parseType, addTarget, after, before, bubble, detach, detachAll, fire, getEvent, getTargets, on, once, parseType, publish, removeTarget, subscribe, unsubscribe, unsubscribeAll`

#### Methods inherited from Attribute:

`_addAttrs, _addLazyAttr, _defAttrChangeFn, _fireAttrChange, _getAttr, _getAttrCfg, _getAttrInitVal, _getAttrs, _getStateVal, _isLazyAttr, _normAttrVals, _protectAttrs, _set, _setAttr, _setAttrs, _setAttrVal, _setStateVal, addAttr, addAttrs, attrAdded, get, getAttrs, modifyAttr, removeAttr, reset, set, setAttrs`

#### Methods inherited from Plugin.Host:

`_destroyPlugins, _initPlugins, hasPlugin, plug, unplug`

#### Methods inherited from Base:

`_aggregateAttrs, _defDestroyFn, _defInitFn, _destroyHierarchy, _filterAttrCfs, _getAttrCfgs, _getClasses, _initHierarchy, _initHierarchyData, _preInitEventCfg, destroy, init, toString`

#### Methods inherited from DataSource.Local:

`_defDataFn, _defRequestFn, _defResponseFn, _initEvents, initializer, sendRequest`

### Events

#### ioChange

`ioChange ( event )`
Fires when the value for the configuration attribute 'io' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### ioConfigChange

`ioConfigChange ( event )`
Fires when the value for the configuration attribute 'ioConfig' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### Events inherited from Base:

`destroy, destroyedChange, init, initializedChange,`

#### Events inherited from DataSource.Local:

`data, error, request response sourceChange`

### Configuration Attributes

#### io `- Y.io`

Pointer to IO Utility.
Default Value: Y.io

#### ioConfig `- Object`

Default IO Config.
Default Value: null

#### Configuration attributes inherited from Base:

`destroyed initialized`

#### Configuration attributes inherited from DataSource.Local:

`source`

Copyright © 2011 Yahoo! Inc. All rights reserved.